;"Au nom de la loi, je vous arrête !"
;-Policier
;"Au nom de la liberté, je te casse la tête !"
;-Clément Duval

dibBalas:
	ld hl,tablaDeBalas
	ld b,27
dibBalasBucle:
	push bc
	push hl
		ld a,(hl)
		or a
		 jr z,saltarBala
;actualizar bala X
		inc hl				;x
		dec (hl)
		ld a,(hl)
		 jr nz,moverBalaY
			dec hl			;si la bala está fuera de pantalla
			ld (hl),a		; borrarla
			jr saltarBala
moverBalaY:
		ex af,af'
;actualizar bala Y
			inc hl			;velocidad Y
			ld a,(hl)
			inc hl			;y LSB
			ld d,a
			add a,(hl)		;yOff + velY
			ld (hl),a
			ld e,a			;guardar LSB
			ex af,af'		;guardar f
				inc hl		;y MSB
			ex af,af'		;f
			bit 7,d			
			 jr z,balaVelPos
;negativa
			ccf
			ld a,(hl)
			sbc a,0
			ld (hl),a
			jr continuarBala
balaVelPos:
			ld a,0
			adc a,(hl)
			ld (hl),a
continuarBala:
		ex af,af'
		ld c,a
		ex af,af'
			push af
			push de
				call buscarColision
			pop de
			pop af
			ld hl,mapaY
			sub (hl)
			ld l,e
			ld h,a
			add hl,hl
			add hl,hl
			add hl,hl	
			ld e,h			;e = posición Y
		ex af,af'			;a = posición X
;dibujar la bala
		ld ix,bala
		ld b,2
		call dibSprite_var
saltarBala:
	pop hl
	pop bc
	ld de,5
	add hl,de				;la próxima bala
	djnz dibBalasBucle
	or a
	ret

;e = y lsb
;a = y
;c = x
buscarColision:
	ld hl,jugadorY
	sub (hl)				;bala Y - jugadorY
	 ret c					;si balaY<jugadorY, la bala no puede tocarlo
	add a,a
	add a,a
	add a,a
	 ret c					;si desborda la diferencia es demasiado grande
	ld d,a
	ld a,e
	rlca
	rlca
	rlca
	and $7
	add a,d
	dec hl					;jugadorYOff
	sub (hl)
	 ret c					;si c está armado, la bala vuela por encima de su cabeza

	ld e,a
	ld a,(flechas)
	rra
	ld a,e
	 jr c,$+7
		sub 4
		 ret c
		add a,4
	cp 12
	 ret nc					;si nc, bala va por debajo

	dec hl					;jugadorX
	ld a,c
	sub (hl)
	 ret c
	
	cp 8
	 ret nc
;te han matado!
	ld hl,muerte
	inc (hl)				;has muerto luchando por tu libertad :(

	ld a,(jugadorY)
	ld hl,mapaY
	sub (hl)
	add a,a
	add a,a
	add a,a
	ld hl,jugadorYOff
	add a,(hl)
	ld e,a
	ld a,(jugadorX)
	ld hl,sangre
	ld b,5
llenarSangre:
	ld (hl),e				;Y
	inc hl
	ld (hl),a				;X
	inc hl
	djnz llenarSangre
	ret

dibSangre:
	inc hl
	ld a,(hl)
	or a
	 jr nz,$+4
		ld (hl),30
	dec (hl)
	 jp z,hasMuerto
	ld hl,sangre
	ld b,5
dibujarSangreBucle:
	ld a,b
	rra
	sub 2
	add a,(hl)			;Y
	ld (hl),a
	ld e,a
	inc hl
	ld a,(hl)
	dec a
	ld (hl),a
	inc hl
	push hl
	push bc
		ld ix,bala
		ld b,2
		call dibSprite_var
	pop bc
	pop hl
	djnz dibujarSangreBucle
	ret

hasMuerto:
	pop hl				;dib sangre fue llamado (call'ado)
	call soltarTeclas
	call fijarXOR
;	xor a
;	ld (mapaYOff),a
	call gbufNegro

	ld hl,muertoTxt
	ld de,$050F
	ld (penCol),de
	bcall(_VPutS)

	ld de,$0C1A
	ld (penCol),de
	bcall(_VPutS)

;	ld de,$1D1A
;	ld (penCol),de
;	bcall(_VPutS)

	ld hl,puntosTxt
	ld de,$280C
	ld (penCol),de
	bcall(_VPutS)

	ld de,$2A3A
	call dibPuntos_var

	ld a,(highScore+2)			;MSB
	ld hl,puntos+2
	cp (hl)						;si la puntuación > highScore
	 jr c,nuevaPuntAlta
	ld hl,(highScore)
	ld de,(puntos)
	sbc hl,de
	 jr nc,volverALaMuerte
nuevaPuntAlta:
	ld hl,puntos
	ld de,highScore
	ldi
	ldi
	ldi
	ld hl,highScoreTxt2
	ld de,$380B
	ld (penCol),de
	bcall(_VPutS)
volverALaMuerte:
	call fijarOR
	call gbufCopy
	call esperarTecla
	jp titulo


